#!/usr/local/bin/perl
#----------------------------------------------------
# option.pl
#----------------------------------------------------
# --Acquires user input for option pricing
# --Invokes parallel option pricing server
# --Generates screen to view option pricing results 
#----------------------------------------------------


#require "/home/B8E/miloje/lib/cgi/perl/cgi_handlers.pl";
require "/home/B6H/development/deneb_cgi-bin/miloje/cgi_handlers.pl";

&html_header("Option Valuation Charts");
&get_request;

$MC_ROOT="/home/B8E/miloje/Demo/PIMC";
$SCRIPT_ROOT_URL = "http://deneb.npac.syr.edu:3768/cgi-bin/miloje";
$symbol = $rqpairs{'symbol'};

$pid = $$;

print "<pre>";
$NMCCycles = 1;
$RNGSeed = 1234;
$Blocks = $rqpairs{'blocks'};
$BlockSize = 5;
$Relax = 1000;

eval `rm -f $MC_ROOT/mc.in`;
print "before mc.in\n";
print "$MC_ROOT/mc.in\n";
open(MC_INIT,">$MC_ROOT/mc.in") || die "Cannot create MC setup file";
print(MC_INIT "NMCCycles\n");
print(MC_INIT "$NMCCycles\n");
print(MC_INIT "RNG Seed\n");
print(MC_INIT "$RNGSeed\n");
print(MC_INIT "Blocks\n");
print(MC_INIT "$Blocks\n");
print(MC_INIT "Block size\n");
print(MC_INIT "$BlockSize\n");
print(MC_INIT "Relaxation blocks\n");
print(MC_INIT "$Relax\n");
print "created $MC_ROOT/mc.in\n";

@InitPrices = split(" ",$rqpairs{'prices'});
$NumDOF = $#InitPrices + 1;

$NumTimeValues = $NumTimeSteps;
$RiskFreeRate = $rqpairs{'rate'};

$str=$rqpairs{'strikes'};
@Strikes = split(" ",$str);
$NumStrikes = $#Strikes + 1;

$NumTimeSteps= $rqpairs{'nt'};
$StartDate = 0;
$EndDate = $NumTimeSteps;
$delT= 1;
$OutFile= "proxy.out";

print "@Strikes\n";
eval `rm -f $MC_ROOT/factor.in`;
open(FACTOR_INIT,">$MC_ROOT/factor.in") || die "Cannot create factor setup file";
print(FACTOR_INIT "Degrees of freedom\n");
print(FACTOR_INIT "$NumDOF\n");
#print(FACTOR_INIT "Periods to maturity\n");
#print(FACTOR_INIT "$NumTimeSteps\n");
print(FACTOR_INIT "Start date\n");
print(FACTOR_INIT "$StartDate\n");
print(FACTOR_INIT "End date\n");
print(FACTOR_INIT "$EndDate\n");
print(FACTOR_INIT "Period length\n");
print(FACTOR_INIT "$delT\n");
print(FACTOR_INIT "Output file\n");
print(FACTOR_INIT "$OutFile\n");

#$simout = "tmpSimulation".".".$pid;
$simout = "price.out";
eval `rm -f $MC_ROOT/option.in`;
open(OPTION_INIT,">$MC_ROOT/option.in") || die "Cannot create option setup file";
print(OPTION_INIT "Num time values\n");
print(OPTION_INIT "$NumTimeSteps\n");
print(OPTION_INIT "Num initial prices\n");
print(OPTION_INIT "$NumDOF\n");
print(OPTION_INIT "Num strikes\n");
print(OPTION_INIT "$NumStrikes\n");
print(OPTION_INIT "Initial Prices\n");
$index=0;
$ndof = $NumDOF;
while($ndof--) {
 $index++;
 print(OPTION_INIT "$index $InitPrices[$index-1]\n");
}
print(OPTION_INIT "Risk free interest rate\n");
print(OPTION_INIT "$RiskFreeRate\n");
print(OPTION_INIT "Payoff Type\n");
print(OPTION_INIT "0\n");
print(OPTION_INIT "Num int payoff params\n");
print(OPTION_INIT "1\n");
print(OPTION_INIT "Num strikes\n");
print(OPTION_INIT "$NumStrikes\n");
print(OPTION_INIT "Strikes\n");

$index=0;
$ns = $NumStrikes;
while($ns--) {
 $index++;
 print(OPTION_INIT "$index $Strikes[$index-1]\n");
}

print "ready to dist\n";
$dist = $rqpairs{'distribution'};
$coupling = $rqpairs{'coupling'};
open(DIST,">$MC_ROOT/dist.in") || die "Cannot create process setup file";
print(DIST "Distribution\n");
print(DIST "$dist\n");
print(DIST "Variances\n");
$index=0;
$ndof = $NumDOF;
while($ndof--) {
       	$index++;
       	print(DIST "$index $var\n");
}
if($dist eq 1) {
	print(DIST "Couplings\n");
	$index=0;
	$ndof = $NumDOF;
	while($ndof--) {
 	       $index++;
 	       print(DIST "$index 1\n");
	       print(DIST "$index 1 $coupling\n");
        }
}
if($dist eq 5) {
	print(DIST "Couplings\n");
	$index=0;
	$ndof = $NumDOF;
	while($ndof--) {
 	       $index++;
 	       print(DIST "$index 1\n");
	       print(DIST "$index 1 $coupling\n");
	       print(DIST "$index 2 3.0\n");
        }
}
print(DIST "Initial paths\n");
$index=0;
$ndof = $NumDOF;
while($ndof--) {
 $index++;
 print(DIST "$index 0.0\n");
}

print "<hr>";
print "Simulation request submitted";
print "<hr>";
print "<em> Simulation completed! </em>";
print "<hr>";
print "<h2> CHARTS </h2>";
print "<FORM METHOD=POST ACTION=$SCRIPT_ROOT_URL/result.cgi>";
print "<INPUT TYPE=hidden NAME=symbol VALUE=$rqpairs{'symbol'}>";
print "<INPUT TYPE=hidden NAME=datafile VALUE=$simout>";
print "<INPUT TYPE=hidden NAME=distribution VALUE=$DistType>";

print "<hr>";
print "Strike price:";
print "<SELECT NAME=StrikePrice>\n";
$index=0;
$ns = $NumStrikes;
while($ns--) {
 $index++;
 print "<OPTION VALUE=$Strikes[$index-1]> $Strikes[$index-1]\n";
}
print "</SELECT>\n"; 

print "Stock price:"; 
print "<SELECT NAME=UnderlyingPrice>\n";
$index=0;
$ndof = $NumDOF;
while($ndof--) {
    $index++;
    print "<OPTION VALUE=$InitPrices[$index-1]> $InitPrices[$index-1]\n";
}
print "</SELECT>\n"; 

print "Contract maturity:";
print "<SELECT NAME=TimeStep>\n";
$index=0;
$t = $NumTimeSteps+1;
while($t--) {
    $index++;
    print "<OPTION VALUE=$index> $index\n";
}
print "</SELECT>\n"; 
print "<hr>";

print "<b> <INPUT TYPE=SUBMIT VALUE=Plot> </b>";
print <<STOPC;
               <SELECT NAME="Contract">
               <OPTION VALUE="CALL"> Call option
               <OPTION VALUE="PUT"> Put option
            </SELECT>
STOPC
print <<STOPW;
               <SELECT NAME="What">
               <OPTION VALUE="PRICE"> price
               <OPTION VALUE="DELTA"> delta
            </SELECT>
STOPW
print " vs. ";
print <<STOPPT;
               <SELECT NAME="PlotType">
               <OPTION VALUE="1"> time to maturity
               <OPTION VALUE="2"> strike price
               <OPTION VALUE="3"> underlying price
            </SELECT>
STOPPT
print " or ";
print " <INPUT TYPE=RESET VALUE=Cancel>";
print "</body>";
print "</html>";
exit;

